package com.usky.dxtop.service.job;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.usky.dxtop.common.utils.http.HttpUtils;
import com.usky.dxtop.model.Staff;
import com.usky.dxtop.service.DeptService;
import com.usky.dxtop.service.StaffService;
import com.usky.dxtop.service.api.SmApi;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import java.util.List;
import java.util.TreeMap;

/**
 * 世贸定时任务
 * @author yq
 * @date 2021/9/28 14:47
 */
@Component
@Slf4j
public class SmJob {

    @Autowired
    private StaffService staffService;

    @Autowired
    private DeptService deptService;


    public void personExecute(){
        boolean isNext = true;
        int page = 1;
        int size = 100;
        while (isNext){
            try {
                String personUrl = String.format("%s?page=%s&size=%s", SmApi.PERSON_URL, page, size);
                TreeMap<String, Object> treeMap = SmApi.generatePersonParam(null, null, null, null);
                String result = HttpUtils.sendPost(personUrl, JSONObject.toJSONString(treeMap), SmApi.sign(treeMap));
                JSONObject jsonObject = JSONObject.parseObject(result);
                if ("200".equals(jsonObject.get("status").toString())){
                    JSONObject data = jsonObject.getJSONObject("data");
                    JSONArray content = data.getJSONArray("content");
                    if(content != null && content.size() > 0) {
                        List<Staff> staffList = content.toJavaList(Staff.class);
                        if (CollectionUtils.isEmpty(staffList)){
                            isNext = false;
                        }else {
                            page++;
                        }
                    }else {
                        isNext = false;
                    }
                }else {
                    break;
                }
            }catch (Exception e){
                log.info("smJob异常"+e);
                break;
            }
        }
        log.info("smjob 定时任务完成");
    }

//    public void  test(){
//        Map<String,Object> map = new HashMap<>();
//        map.put("status","200");
//        Map<String,Object> map1 = new HashMap<>();
//        List<Staff> list = new ArrayList<>();
//        Staff staff = new Staff();
//        staff.setDeptSort(1);
//        list.add(staff);
//        map1.put("content",list);
//        map.put("data",map1);
//    }

//    public void add(String url, TreeMap<String,Object> param, Class tClass, IService iService){
//        boolean isNext = true;
//        int page = 1;
//        int size = 100;
//        while (isNext){
//            try {
//                String personUrl = String.format("%s?page=%s&size=%s", url, page, size);
////                TreeMap<String, Object> treeMap = SmApi.generatePersonParam(null, null, null, null);
//                String result = HttpUtils.sendPost(personUrl, JSONObject.toJSONString(param), SmApi.sign(param));
//                JSONObject jsonObject = JSONObject.parseObject(result);
//                if ("200".equals(jsonObject.get("status").toString())){
//                    JSONObject data = jsonObject.getJSONObject("data");
//                    JSONArray content = data.getJSONArray("content");
//                    if(content != null && content.size() > 0) {
//                        List<Staff> staffList = content.toJavaList(tClass);
//                        staffList.forEach(staff -> iService.save(staff));
//                        if (CollectionUtils.isEmpty(staffList)){
//                            isNext = false;
//                        }else {
//                            page++;
//                        }
//                    }else {
//                        isNext = false;
//                    }
//                }else {
//                    break;
//                }
//            }catch (Exception e){
//                log.info("smJob异常"+e);
//                break;
//            }
//        }
//    }

}
